<?php
/**
 * @category  Joomla
 * @package   Joomla
 * @author    Folcomedia <contact@folcomedia.fr>
 * @copyright 2013 Folcomedia
 * @license   http://www.opensource.org/licenses/mit-license.html  MIT License
 * @link      http://www.folcomedia.fr
 */


// No direct access.
defined('_JEXEC') or die;

class plgContentFmfulltext extends JPlugin
{
/**
 * Plugin Système Folcomedia PIWIK
 *
 * @category Joomla
 * @package  Joomla
 * @author   Folcomedia <contact@folcomedia.fr>
 * @license  http://www.opensource.org/licenses/mit-license.html  MIT License
 * @link     http://www.folcomedia.fr
 */
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
			
		if ($context == "com_content.featured" || $context == "com_content.category") {

			$db		= JFactory::getDbo();	
			$user	= JFactory::getUser();
			$app	= JFactory::getApplication();
			$lang	= JFactory::getLanguage();
			$nullDate = $db->getNullDate();

			$date	= JFactory::getDate();
			$config	= JFactory::getConfig();
			$now = $date->toSql();

			//id de l'article à traiter
			$uid	= $article->id;			
			$row=$article;
			$option	= 'com_content';
			$canPublish = $user->authorise('core.edit.state', $option.'.article.'.$row->id);

			if (is_object($article)){
						
				//Nombre d'article à afficher au complet
				$num_article_complet = $article->params->get('num_leading_articles');	
				$num_article_intro = $article->params->get('num_intro_articles');	
				$num_columns = $article->params->get('num_columns');	
				$num_articles_total_par_page=($num_article_complet+$num_article_intro)*$num_columns;

				// check for category selection
				$tab_id_categorie = $article->params->get('featured_categories');
				if ($article->params->get('featured_categories') && implode(',', $article->params->get('featured_categories'))  == true) {
					$featuredCategories = implode(',',$article->params->get('featured_categories'));
					$where_featuredCategories= 'a.catid IN ('. $featuredCategories .')';
				} 
				elseif (is_array($article->params->get('featured_categories')) && count($article->params->get('featured_categories')) == 1 && empty($tab_id_categorie[0])) {
					$where_featuredCategories = "1";
				}	
				elseif ($context == "com_content.category") {
					$where_featuredCategories = 'a.catid IN (SELECT id from #__categories WHERE (parent_id = '.JRequest::getInt("id").' OR id = '.JRequest::getInt("id").'))';
					
				}					
				$articleOrderby		= $article->params->get('orderby_sec', 'rdate');		
				$articleOrderDate = $article->params->get('order_date');
				$categoryOrderby = $article->params->def('orderby_pri', '');
				$secondary = ContentHelperQuery::orderbySecondary($articleOrderby, $articleOrderDate) . ', ';
				$primary = ContentHelperQuery::orderbyPrimary($categoryOrderby);
				$orderby = $primary . ' ' . str_replace ( 'fp.ordering' , 'a.ordering' , $secondary ) . 'a.created';
				
				$xwhere = ' AND (a.state = 1 OR a.state = -1)' .
				' AND (publish_up = '.$db->Quote($nullDate).' OR publish_up <= '.$db->Quote($now).')' .
				' AND (publish_down = '.$db->Quote($nullDate).' OR publish_down >= '.$db->Quote($now).')';

				$featured="";
				if ($context == "com_content.featured") {
					$featured = " AND featured = 1 ";	
				}
	
				// Array of articles in same category correctly ordered.
				$query	= $db->getQuery(true);
		       //sqlsrv changes
				$query->select('a.id,a.introtext,a.fulltext');
				$query->from('#__content AS a');
				$query->leftJoin('#__categories AS c ON c.id = a.catid');
				$query->where(' '.$where_featuredCategories.' '.$featured.' AND a.state = '. (int)$row->state
							. ($canPublish ? '' : ' AND a.access = ' .(int)$row->access) . $xwhere);
				$query->order($orderby);
				if ($app->isSite() && $app->getLanguageFilter()) {
					$query->where('a.language in ('.$db->quote($lang->getTag()).','.$db->quote('*').')');
				}
	
				$db->setQuery($query);

				$list = $db->loadObjectList();	
				
				//Affiche les articles en complet que sur la première page
				if ($this->params->get('fm_full_text_number_page') == 0) {
					for ($i=0; $i < $num_article_complet; $i++) {
						if ($uid == $list[$i]->id) {
							//affichage full texte de l'article	
							if($this->params->get('choix_fulltext') == 0){
								$article->text = $list[$i]->fulltext.'<br />';
							}
							//affichage intro + full texte de l'article	
							elseif ($this->params->get('choix_fulltext') == 1) {
								//Affichage en entier du texte sans SHOW / HIDE									
								if ($this->params->get('fm_full_text_show_hide') == 0 || ($this->params->get('fm_full_text_show_hide') == 1 && $list[$i]->fulltext == '' ) ) {
									$article->text = $list[$i]->introtext.$list[$i]->fulltext.'<br />';	
								}
								//Affichage en entier du texte avec SHOW / HIDE
								elseif ($this->params->get('fm_full_text_show_hide') == 1) {
									$article->text = '<div id="fmrft_'.$uid.'">'.$list[$i]->introtext.'</div><div class="fmrft">'.$list[$i]->fulltext.'</div><button id="'.$uid.'" class="fmrftbtnShowhide fmrftClose btn">'.JText::_("JSHOW").'</button><br />';
								}				
							}
		
							//affichage du lien lire la suite
							if ($this->params->get('choix_fulltext_show_readmore') == 0) {
								$article->params->set('show_readmore',0);
							}
							elseif($this->params->get('choix_fulltext_show_readmore') == 1){
								$article->params->set('show_readmore',1);
							}
						}
					}
					
				}	
				//Affiche les articles en complet sur toutes les page
				elseif($this->params->get('fm_full_text_number_page') == 1) {

					for ($i=0; $i < sizeof($list); $i++) { 
						if ($i % $num_articles_total_par_page == 0 || $i % $num_articles_total_par_page == 1) {
							if ($uid == $list[$i]->id) {
								//affichage full texte de l'article	
								if($this->params->get('choix_fulltext') == 0){
									$article->text = $list[$i]->fulltext.'<br />';
								}
								//affichage intro + full texte de l'article	
								elseif ($this->params->get('choix_fulltext') == 1) {
									//Affichage en entier du texte sans SHOW / HIDE									
									if ($this->params->get('fm_full_text_show_hide') == 0 || ($this->params->get('fm_full_text_show_hide') == 1 && $list[$i]->fulltext == '' ) ) {
										$article->text = $list[$i]->introtext.$list[$i]->fulltext.'<br />';	
									}
									//Affichage en entier du texte avec SHOW / HIDE
									elseif ($this->params->get('fm_full_text_show_hide') == 1) {
										$article->text = '<div id="fmrft_'.$uid.'">'.$list[$i]->introtext.'</div><div class="fmrft">'.$list[$i]->fulltext.'</div><button id="'.$uid.'" class="fmrftbtnShowhide fmrftClose btn">'.JText::_("JSHOW").'</button><br />';
									}														
								}
			
								//affichage du lien lire la suite
								if ($this->params->get('choix_fulltext_show_readmore') == 0) {
									$article->params->set('show_readmore',0);
								}
								elseif($this->params->get('choix_fulltext_show_readmore') == 1){
									$article->params->set('show_readmore',1);
								}
							}						
						}
					}
					
				}				

			}	
		}
	}

	function onAfterRender()
    {
		if ($this->params->get('fm_full_text_show_hide') == 1) {
		    $app = JFactory::getApplication();
	        if (!$app->isSite()) {
	            return;
	        }
	
	        // chaine généré par piwik
			$Fmrft_js_string='<script type="text/javascript"> 
			jQuery(".fmrft").each(function(idx){
				jQuery(this).css("display", "none");
			});
			
			jQuery(".fmrftbtnShowhide").click(function() {
				if(jQuery(this).hasClass("fmrftClose")){
					jQuery(this).prev("div").show("fast", function () {
					});
					jQuery(this).html("'.JText::_("JHIDE").'");
					jQuery(this).removeClass("fmrftClose");
					jQuery(this).addClass("fmrftOpen");
				}
				else if(jQuery(this).hasClass("fmrftOpen")){
					jQuery(this).prev("div").hide("fast");
					jQuery(this).html("'.JText::_("JSHOW").'");
					jQuery(this).removeClass("fmrftOpen");
					jQuery(this).addClass("fmrftClose");				
					document.location="#fmrft_"+jQuery(this).attr("id");
				}
	        });</script>';
	        $buffer = JResponse::getBody();
	        
	        // Remplacement dans le code
	        $buffer = str_replace('</body>',$Fmrft_js_string.'</body>', $buffer);
	        JResponse::setBody($buffer);
		}	
    }

}
